unit DebugUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls;

type
  TDebugForm = class(TForm)
    InLabel0: TLabel;
    Label4: TLabel;
    InLabel1: TLabel;
    Label3: TLabel;
    InLabel2: TLabel;
    Label5: TLabel;
    InLabel3: TLabel;
    Label6: TLabel;
    RelayButton0: TSpeedButton;
    Label8: TLabel;
    RelayButton1: TSpeedButton;
    Label9: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure RelayButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  protected
    InLabel: array[0..3] of TLabel;
    RelayButton: array[0..1] of TSpeedButton;
    { Private declarations }
  public
    procedure NoteIIROData(ReadErr, IIData, ROData: LongWord);
    { Public declarations }
  end;

var
  DebugForm: TDebugForm;



implementation

uses MainUnit;

{$R *.DFM}

function IBoolToColor(IBool: LongWord): TColor;
begin
  if IBool <> 0 then
    Result := clRed
  else
    Result := clBlack
  ;
end;

{ TDebugForm }

procedure TDebugForm.FormCreate(Sender: TObject);
begin
  RelayButton[0] := RelayButton0;
  RelayButton[1] := RelayButton1;
  InLabel[0] := InLabel0;
  InLabel[1] := InLabel1;
  InLabel[2] := InLabel2;
  InLabel[3] := InLabel3;
end;

procedure TDebugForm.NoteIIROData(ReadErr, IIData, ROData: LongWord);
const
  InputColor: array[Boolean] of TColor = (clBlack, clRed);

var
  ErrStr: AnsiString;
  iBit: Integer;

begin
  if ReadErr = ERROR_SUCCESS then begin
    for iBit := 0 to High(InLabel) do begin
      InLabel[iBit].Color := InputColor[(IIData and (1 shl iBit)) <> 0];
      InLabel[iBit].ShowHint := False;
    end;
  end
  else begin
    ErrStr := 'Error ' + IntToStr(ReadErr) + ' from GetCommModemStatus.';
    for iBit := 0 to High(InLabel) do begin
      InLabel[iBit].ParentColor := True;
      InLabel[iBit].Hint := ErrStr;
      InLabel[iBit].ShowHint := True;
    end;
  end;

  for iBit := 0 to High(RelayButton) do
    RelayButton[iBit].Down := (ROData and (1 shl iBit)) <> 0
  ;
end;

procedure TDebugForm.RelayButtonClick(Sender: TObject);
var
  I: Integer;

begin
  I := (Sender as TControl).Tag;
  MainForm.UserRelaySet(I, RelayButton[I].Down);
end;

procedure TDebugForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DebugForm := nil;
  Action := caFree;
end;

end.
